"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const object_1 = require("./helpers/object");
function BodyRow({ tableHeaders, data, rowIdx, classes, components, onClick }) {
    const row = [];
    for (let i = 0; i < tableHeaders.length; i += 1) {
        const { cell, cellProps = {} } = tableHeaders[i];
        let value = '';
        if (cell === undefined) {
            value = data[rowIdx][tableHeaders[i].prop];
        }
        else {
            value = cell(data[rowIdx]);
        }
        row.push(react_1.default.createElement(components.TableCell, { key: `col-${rowIdx}${i}`, className: (0, object_1.makeClasses)('tbody-td', classes.tbodyCol, typeof cellProps.className === 'function'
                ? cellProps.className(data[rowIdx])
                : cellProps.className), style: typeof cellProps.style === 'function'
                ? cellProps.style(data[rowIdx])
                : cellProps.style }, value));
    }
    function onRowClick() {
        if (typeof onClick === 'function') {
            onClick(data[rowIdx]);
        }
    }
    return (react_1.default.createElement(components.TableRow, { className: (0, object_1.makeClasses)('tbody-tr', classes.tbodyRow), onClick: onRowClick }, row));
}
exports.default = BodyRow;
