"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const NavButton_1 = __importDefault(require("./modules/NavButton"));
const object_1 = require("./helpers/object");
function Pagination({ rowsPerPage, currentPage, onPageNavigate, labels, maxPage, classes, components: { Button, ButtonGroup } }) {
    const paginateHandler = (0, react_1.useCallback)((pageNum) => {
        return () => onPageNavigate(pageNum);
    }, [onPageNavigate]);
    let renderedElements = null;
    if (rowsPerPage !== undefined && maxPage !== undefined) {
        const buttons = [];
        const firstLabel = labels.first || 'First';
        const prevLabel = labels.prev || 'Prev';
        const nextLabel = labels.next || 'Next';
        const lastLabel = labels.last || 'Last';
        const isCurrentPageOutOfBounds = currentPage > maxPage;
        let startNumber;
        let i = 0;
        let hasPrev = true;
        let hasNext = true;
        if (currentPage === 1) {
            // Active button is the first one.
            startNumber = 1;
            hasPrev = false;
            hasNext = maxPage > 1;
        }
        else if (currentPage === maxPage && maxPage !== 1) {
            // Active button is in the last.
            startNumber = maxPage - 2 > 0 ? currentPage - 2 : 1;
            hasNext = false;
        }
        else {
            // Active button is in the middle.
            startNumber = currentPage - 1;
        }
        buttons.push(react_1.default.createElement(NavButton_1.default, { Component: Button, className: classes.paginationButton, key: `page-${firstLabel}`, pageNumber: 1, disabled: !hasPrev, onPageNavigate: paginateHandler, label: firstLabel }), react_1.default.createElement(NavButton_1.default, { Component: Button, className: classes.paginationButton, key: `page-${prevLabel}`, 
            // If out of bounds, prev button refers to the last page.
            pageNumber: isCurrentPageOutOfBounds ? maxPage : currentPage - 1, disabled: !hasPrev, onPageNavigate: paginateHandler, label: prevLabel }));
        if (!isCurrentPageOutOfBounds) {
            while (i < 3 && startNumber <= maxPage) {
                buttons.push(react_1.default.createElement(NavButton_1.default, { Component: Button, key: `page-btn-${i}`, pageNumber: startNumber, disabled: currentPage === startNumber, onPageNavigate: paginateHandler, label: startNumber, className: classes.paginationButton }));
                i += 1;
                startNumber += 1;
            }
        }
        else {
            // If current page is more than maxPage, we disable the button.
            // This is intentional so the user knows that no data in there.
            hasNext = false;
            buttons.push(react_1.default.createElement(NavButton_1.default, { Component: Button, key: `page-btn-${startNumber}`, className: classes.paginationButton, pageNumber: currentPage - 1, disabled: true, onPageNavigate: paginateHandler, label: currentPage }));
        }
        buttons.push(react_1.default.createElement(NavButton_1.default, { Component: Button, className: classes.paginationButton, key: `page-${nextLabel}`, pageNumber: currentPage + 1, disabled: !hasNext, onPageNavigate: paginateHandler, label: nextLabel }), react_1.default.createElement(NavButton_1.default, { Component: Button, className: classes.paginationButton, key: `page-${lastLabel}`, pageNumber: maxPage, disabled: !hasNext, onPageNavigate: paginateHandler, label: lastLabel }));
        renderedElements = (react_1.default.createElement(ButtonGroup, { className: (0, object_1.makeClasses)('ButtonGroup__root', classes.paginationButtonGroup) }, buttons));
    }
    return renderedElements;
}
exports.default = Pagination;
