"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PaginationOptsGroup = void 0;
const react_1 = __importDefault(require("react"));
const object_1 = require("./helpers/object");
const Form_1 = __importDefault(require("react-bootstrap/Form"));
function PaginationOptsGroup({ classes, labels, value, onChange, options }) {
    return (react_1.default.createElement(Form_1.default, { className: (0, object_1.makeClasses)('paginationOpts__root', classes.paginationOptsForm) },
        react_1.default.createElement(Form_1.default.Group, { controlId: "formGroupPagination", className: classes.paginationOptsFormGroup },
            react_1.default.createElement("span", { className: classes.paginationOptsFormText },
                labels.show || 'Show',
                ' '),
            react_1.default.createElement(Form_1.default.Control, { name: "form-control-pagination", defaultValue: value, as: "select", placeholder: "select", onChange: onChange, className: classes.paginationOptsFormControl }, options.map((option, idx) => {
                const optionProps = {
                    key: `page-opt-${option}`,
                    value: option
                };
                return react_1.default.createElement("option", Object.assign({}, optionProps), option);
            })),
            react_1.default.createElement("span", { className: classes.paginationOptsFormText },
                ' ',
                labels.entries || 'entries'))));
}
exports.PaginationOptsGroup = PaginationOptsGroup;
function PaginationOpts({ labels, rowsPerPage, rowsPerPageOption, onRowsPerPageChange, classes, CustomPaginationOptsGroup }) {
    function onRowsPerPageChangeHandler(e) {
        onRowsPerPageChange(Number(e.target.value));
    }
    let renderedElements = null;
    if (rowsPerPage !== undefined) {
        let opts = [rowsPerPage];
        // Make sure there are no duplicates being pushed.
        if (rowsPerPageOption !== undefined) {
            rowsPerPageOption.forEach((opt) => {
                if (!opts.includes(opt) && typeof opt === 'number') {
                    opts.push(opt);
                }
            });
            // Order the pagination options ascending.
            opts = opts.sort((a, b) => {
                if (a < b) {
                    return -1;
                }
                else if (a > b) {
                    return 1;
                }
                return 0;
            });
        }
        // Only render option if the length is more than 1.
        if (opts.length > 1) {
            const UsedPaginationOpts = CustomPaginationOptsGroup || PaginationOptsGroup;
            renderedElements = (react_1.default.createElement(UsedPaginationOpts, { classes: classes, labels: labels, onChange: onRowsPerPageChangeHandler, options: opts, value: rowsPerPage }));
        }
    }
    return renderedElements;
}
exports.default = PaginationOpts;
