"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const BodyRow_1 = __importDefault(require("./BodyRow"));
const object_1 = require("./helpers/object");
function TableBody({ tableHeaders, labels, data, classes, components: { TableBody, TableRow, TableCell }, onRowClick }) {
    const body = [];
    const dataLength = data.length;
    if (dataLength !== 0) {
        for (let i = 0; i < dataLength; i += 1) {
            body.push(react_1.default.createElement(BodyRow_1.default, { key: `row-${i}`, classes: classes, components: {
                    TableRow,
                    TableCell
                }, tableHeaders: tableHeaders, data: data, onClick: onRowClick, rowIdx: i }));
        }
    }
    else {
        body.push(react_1.default.createElement(TableRow, { key: `row-zero-length`, className: "tbody-tr" },
            react_1.default.createElement(TableCell, { className: "tbody-td", colSpan: tableHeaders.length }, labels.noResults || 'No results to be shown.')));
    }
    return (react_1.default.createElement(TableBody, { className: (0, object_1.makeClasses)('tbody', classes.tbody) }, body));
}
exports.default = TableBody;
