import React from 'react';
import { makeClasses } from './helpers/object';
export default function BodyRow({ tableHeaders, data, rowIdx, classes, components, onClick }) {
    const row = [];
    for (let i = 0; i < tableHeaders.length; i += 1) {
        const { cell, cellProps = {} } = tableHeaders[i];
        let value = '';
        if (cell === undefined) {
            value = data[rowIdx][tableHeaders[i].prop];
        }
        else {
            value = cell(data[rowIdx]);
        }
        row.push(React.createElement(components.TableCell, { key: `col-${rowIdx}${i}`, className: makeClasses('tbody-td', classes.tbodyCol, typeof cellProps.className === 'function'
                ? cellProps.className(data[rowIdx])
                : cellProps.className), style: typeof cellProps.style === 'function'
                ? cellProps.style(data[rowIdx])
                : cellProps.style }, value));
    }
    function onRowClick() {
        if (typeof onClick === 'function') {
            onClick(data[rowIdx]);
        }
    }
    return (React.createElement(components.TableRow, { className: makeClasses('tbody-tr', classes.tbodyRow), onClick: onRowClick }, row));
}
