import React from 'react';
import BodyRow from './BodyRow';
import { makeClasses } from './helpers/object';
export default function TableBody({ tableHeaders, labels, data, classes, components: { TableBody, TableRow, TableCell }, onRowClick }) {
    const body = [];
    const dataLength = data.length;
    if (dataLength !== 0) {
        for (let i = 0; i < dataLength; i += 1) {
            body.push(React.createElement(BodyRow, { key: `row-${i}`, classes: classes, components: {
                    TableRow,
                    TableCell
                }, tableHeaders: tableHeaders, data: data, onClick: onRowClick, rowIdx: i }));
        }
    }
    else {
        body.push(React.createElement(TableRow, { key: `row-zero-length`, className: "tbody-tr" },
            React.createElement(TableCell, { className: "tbody-td", colSpan: tableHeaders.length }, labels.noResults || 'No results to be shown.')));
    }
    return (React.createElement(TableBody, { className: makeClasses('tbody', classes.tbody) }, body));
}
